VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Setftime sample from BlackBeltVB.com"
   ClientHeight    =   2325
   ClientLeft      =   1695
   ClientTop       =   1545
   ClientWidth     =   6120
   Height          =   2730
   Left            =   1635
   LinkTopic       =   "Form1"
   ScaleHeight     =   2325
   ScaleWidth      =   6120
   Top             =   1200
   Width           =   6240
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   1800
      TabIndex        =   0
      Text            =   "c:\temp\1.txt"
      Top             =   960
      Width           =   2415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Change File Time"
      Height          =   495
      Left            =   2040
      TabIndex        =   2
      Top             =   1680
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Filename:"
      Height          =   255
      Left            =   960
      TabIndex        =   3
      Top             =   960
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   $"Setftime.frx":0000
      Height          =   615
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5895
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Setftime sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/setftime.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This sample shows how to set a file date/time.
' Note that you must first Open the file and get a
' file handle.

' OpenFile() Flags
Private Const OF_READ = &H0
Private Const OF_WRITE = &H1
Private Const OF_READWRITE = &H2
Private Const OF_SHARE_COMPAT = &H0
Private Const OF_SHARE_EXCLUSIVE = &H10
Private Const OF_SHARE_DENY_WRITE = &H20
Private Const OF_SHARE_DENY_READ = &H30
Private Const OF_SHARE_DENY_NONE = &H40
Private Const OF_PARSE = &H100
Private Const OF_DELETE = &H200
Private Const OF_VERIFY = &H400
Private Const OF_CANCEL = &H800
Private Const OF_CREATE = &H1000
Private Const OF_PROMPT = &H2000
Private Const OF_EXIST = &H4000
Private Const OF_REOPEN = &H8000

Private Const OFS_MAXPATHNAME = 128

' OpenFile() Structure
Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
' Note I've changed the lpLastAccessTime from a FILETIME to a LONG, because I'm going to pass a 0 (Null) 'cause I don't want to set it.
Private Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, ByVal lpLastAccessTime As Long, lpLastWriteTime As FILETIME) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long

Private Sub Command1_Click()
    Dim hFile As Long, OFS As OFSTRUCT, l As Long, cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME, F$
    OFS.cBytes = Len(OFS)

    F$ = Text1.Text

    hFile = OpenFile(F$, OFS, OF_WRITE)
    If hFile > 0 Then
        l = GetFileTime(hFile, cTime, lTime, lwTime)
        l = FileTimeToSystemTime(lwTime, sTime)
        sTime.wYear = 1999
        sTime.wMonth = 1
        sTime.wDay = 1
        l = SystemTimeToFileTime(sTime, lTime)
        l = SetFileTime(hFile, cTime, 0, lTime)
        l = CloseHandle(hFile)
    End If
End Sub
